<?php

namespace Drupal\email_manager\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Url;

/**
 * Controller for email key management.
 */
class EmailKeyController extends ControllerBase {

  /**
   * Lists all email keys.
   *
   * @return array
   *   A render array for the email key list.
   */
  public function listKeys() {
    $list_builder = $this->entityTypeManager()->getListBuilder('email_key');

    $build = [
      '#type' => 'container',
      'add_link' => [
        '#type' => 'link',
        '#title' => $this->t('Add email key'),
        '#url' => Url::fromRoute('email_manager.key_add'),
        '#attributes' => [
          'class' => ['button', 'button--primary'],
        ],
      ],
      'table' => $list_builder->render(),
    ];

    return $build;
  }

  /**
   * Provides the form for adding a new email key.
   *
   * @return array
   *   A render array for the email key form.
   */
  public function addKeyForm() {
    $email_key = $this->entityTypeManager()->getStorage('email_key')->create([]);
    return $this->entityFormBuilder()->getForm($email_key, 'add');
  }
}
