<?php

namespace Drupal\Tests\email_manager\Functional;

use Drupal\Tests\BrowserTestBase;

/**
 * Functional tests for Email Manager module.
 *
 * @group email_manager
 */
class EmailManagerTest extends BrowserTestBase {

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * {@inheritdoc}
   */
  protected static $modules = ['email_manager'];

  /**
   * Tests the email template admin interface.
   */
  public function testTemplateAdmin() {
    $admin_user = $this->drupalCreateUser(['administer email templates']);
    $this->drupalLogin($admin_user);

    // Test template list page.
    $this->drupalGet('/admin/config/system/email-manager');
    $this->assertSession()->statusCodeEquals(200);

    // Test adding a template.
    $edit = [
      'label' => 'Test Template',
      'id' => 'test_template',
      'module' => 'user',
      'key' => 'password_reset',
      'subject' => 'Reset your password',
      'body' => 'Click here to reset: [user:reset-url]',
    ];
    $this->drupalPostForm('/admin/config/system/email-manager/add', $edit, 'Save');
    $this->assertSession()->statusCodeEquals(200);
    $this->assertSession()->pageTextContains('Created email template Test Template.');
  }
}
